<!---
 Licensed to the Apache Software Foundation (ASF) under one or more
 contributor license agreements.  See the NOTICE file distributed with
 this work for additional information regarding copyright ownership.
 The ASF licenses this file to You under the Apache License, Version 2.0
 (the "License"); you may not use this file except in compliance with
 the License.  You may obtain a copy of the License at

      http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
-->
<!---
 +======================================================================+
 |****                                                              ****|
 |****      THIS FILE IS GENERATED BY THE COMMONS BUILD PLUGIN      ****|
 |****                    DO NOT EDIT DIRECTLY                      ****|
 |****                                                              ****|
 +======================================================================+
 | TEMPLATE FILE: readme-md-template.md                                 |
 | commons-build-plugin/trunk/src/main/resources/commons-xdoc-templates |
 +======================================================================+
 |                                                                      |
 | 1) Re-generate using: mvn commons-build:readme-md                    |
 |                                                                      |
 | 2) Set the following properties in the component's pom:              |
 |    - commons.componentid (required, alphabetic, lower case)          |
 |    - commons.release.version (required)                              |
 |                                                                      |
 | 3) Example Properties                                                |
 |                                                                      |
 |  <properties>                                                        |
 |    <commons.componentid>math</commons.componentid>                   |
 |    <commons.release.version>1.2</commons.release.version>            |
 |  </properties>                                                       |
 |                                                                      |
 +======================================================================+
--->
Apache Commons Numbers
===================

[![Build Status](https://github.com/apache/commons-numbers/actions/workflows/maven.yml/badge.svg)](https://github.com/apache/commons-numbers/actions/workflows/maven.yml)
[![Coverage Status](https://codecov.io/gh/apache/commons-numbers/branch/master/graph/badge.svg)](https://app.codecov.io/gh/apache/commons-numbers)
[![Quality Gate Status](https://sonarcloud.io/api/project_badges/measure?project=commons-numbers&metric=alert_status)](https://sonarcloud.io/dashboard?id=commons-numbers)
[![Maven Central](https://maven-badges.herokuapp.com/maven-central/org.apache.commons/commons-numbers-parent/badge.svg)](https://maven-badges.herokuapp.com/maven-central/org.apache.commons/commons-numbers-parent/)

The Apache Commons Numbers project provides number types and utilities.

Documentation
-------------

More information can be found on the [Apache Commons Numbers homepage](https://commons.apache.org/proper/commons-numbers).
The [Javadoc](https://commons.apache.org/proper/commons-numbers/commons-numbers-docs/apidocs) for each of the modules can be browsed:

- [Commons Numbers Core](https://commons.apache.org/proper/commons-numbers/commons-numbers-core/apidocs/)
- [Commons Numbers Complex](https://commons.apache.org/proper/commons-numbers/commons-numbers-complex/apidocs/)
- [Commons Numbers Primes](https://commons.apache.org/proper/commons-numbers/commons-numbers-primes/apidocs/)
- [Commons Numbers Quaternion](https://commons.apache.org/proper/commons-numbers/commons-numbers-quaternion/apidocs/)
- [Commons Numbers Fraction](https://commons.apache.org/proper/commons-numbers/commons-numbers-fraction/apidocs/)
- [Commons Numbers Angle](https://commons.apache.org/proper/commons-numbers/commons-numbers-angle/apidocs/)
- [Commons Numbers Gamma](https://commons.apache.org/proper/commons-numbers/commons-numbers-gamma/apidocs/)
- [Commons Numbers Combinatorics](https://commons.apache.org/proper/commons-numbers/commons-numbers-combinatorics/apidocs/)
- [Commons Numbers Arrays](https://commons.apache.org/proper/commons-numbers/commons-numbers-arrays/apidocs/)
- [Commons Numbers Field](https://commons.apache.org/proper/commons-numbers/commons-numbers-field/apidocs/)
- [Commons Numbers RootFinder](https://commons.apache.org/proper/commons-numbers/commons-numbers-rootfinder/apidocs/)

Questions related to the usage of Apache Commons Numbers should be posted to the [user mailing list](https://commons.apache.org/mail-lists.html).

Where can I get the latest release?
-----------------------------------
You can download source and binaries from our [download page](https://commons.apache.org/proper/commons-numbers/download_numbers.cgi).

Alternatively, you can pull it from the central Maven repositories, for example:

```xml
<dependency>
  <groupId>org.apache.commons</groupId>
  <artifactId>commons-numbers-core</artifactId>
  <version>1.1</version>
</dependency>
<dependency>
  <groupId>org.apache.commons</groupId>
  <artifactId>commons-numbers-complex</artifactId>
  <version>1.1</version>
</dependency>
<dependency>
  <groupId>org.apache.commons</groupId>
  <artifactId>commons-numbers-quaternion</artifactId>
  <version>1.1</version>
</dependency>
```

Contributing
------------

We accept Pull Requests via GitHub. The [developer mailing list][ml] is the main channel of communication for contributors.
There are some guidelines which will make applying PRs easier for us:
+ No tabs! Please use spaces for indentation.
+ Respect the code style.
+ Create minimal diffs - disable on save actions like reformat source code or organize imports. If you feel the source code should be reformatted create a separate PR for this change.
+ Provide JUnit tests for your changes and make sure your changes don't break any existing tests by running ```mvn```.

If you plan to contribute on a regular basis, please consider filing a [contributor license agreement](https://www.apache.org/licenses/#clas).
You can learn more about contributing via GitHub in our [contribution guidelines](CONTRIBUTING.md).

License
-------
This code is under the [Apache Licence v2](https://www.apache.org/licenses/LICENSE-2.0).

See the `NOTICE` file for required notices and attributions.

Donations
---------
You like Apache Commons Numbers? Then [donate back to the ASF](https://www.apache.org/foundation/contributing.html) to support the development.

Additional Resources
--------------------

+ [Apache Commons Homepage](https://commons.apache.org/)
+ [Apache Issue Tracker (JIRA)](https://issues.apache.org/jira/browse/NUMBERS)
+ [Apache Commons Twitter Account](https://twitter.com/ApacheCommons)
+ `#apache-commons` IRC channel on `irc.freenode.org`

[ml]:https://commons.apache.org/mail-lists.html
